/*
 * Copyright (C) 2012 Chris Burdess <dog@gnu.org>
 *
 * Gnome Shell Biff is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * Gnome Shell Biff is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with Gnome Documents; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

try {
    Extension = imports.misc.extensionUtils.getCurrentExtension();
} catch (err) {
    Extension = imports.ui.extensionSystem.extensions["biff@bluezoo.org"];
}
const md5 = Extension.md5;
const base64 = Extension.base64;

function CramMD5(username, password) {
    this.init(username, password);
}

CramMD5.prototype = {

init : function(username, password) {
    this.username = username;
    this.password = password;
    this.complete = false;
},

get_name : function() {
    return "CRAM-MD5";
},

is_plaintext : function() {
    return false;
},

has_initial_response : function() {
    return false;
},

evaluate_challenge : function(challenge) {
    let dchallenge = base64.decode(challenge);
    let digest = md5.hex_hmac_md5(this.password, dchallenge);
    let response = this.username + " " + digest;
    let encoded = base64.encode(response);
    this.complete = true;
    return encoded;
},

is_complete : function() {
    return this.complete;
}

/*hmac_md5 : function(key, text) {
    let k_ipad = [];
    let k_opad = [];
    let B = 64;
    if (key.length > B) {
        key = sasl_array_md5(key);
    }
    for (let i = 0; i < B; i++) {
        let val = 0;
        if (i < key.length) {
            val = key[i];
        }
        k_ipad[i] = (val ^ 0x36) & 0xff;
        k_opad[i] = (val ^ 0x5c) & 0xff;
    }
    let digest = sasl_array_md5(k_ipad.concat(text));
    digest = sasl_array_md5(k_opad.concat(digest));
    return digest;
}*/

};

function Plain(username, password) {
    this.init(username, password);
}

Plain.prototype = {

init : function(username, password) {
    this.username = username;
    this.password = password;
    this.complete = false;
},

get_name : function() {
    return "PLAIN";
},

is_plaintext : function() {
    return true;
},

has_initial_response : function() {
    return true;
},

evaluate_challenge : function(challenge) {
    let response = this.username + "\0" + this.username + "\0" + this.password;
    let encoded = base64.encode(response);
    this.complete = true;
    return encoded;
},

is_complete : function() {
    return this.complete;
}

};

/*function sasl_string_to_array(string) {
    let ret = [];
    for (let i = 0; i < string.length; i++) {
        let c = string.charCodeAt(i);
        ret.push(c); // this should probably handle non-ASCII values better
    }
    return ret;
}

function sasl_array_md5(array) {
    let r0 = sasl_array_to_rstr(array);
    let r1 = md5.rstr_md5(r0);
    let r2 = sasl_rstr_to_array(r1);
    return r2;
}

function sasl_array_to_rstr(array) {
    let ret = "";
    for (let i = 0; i < array.length; i++) {
        ret += String.fromCharCode(array[i]);
    }
    return ret;
}

function sasl_rstr_to_array(rstr) {
    let ret = [];
    for (var i = 0; i < rstr.length; i++) {
        ret.push(rstr.charCodeAt(i));
    }
    return ret;
}

function sasl_hex(array) {
    let hex = new Array(0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66);
    let ret = []
    for (let i = 0; i < array.length; i++) {
        let c = array[i] & 0xff;
        ret.push(hex[(c >>> 4) & 0xf]);
        ret.push(hex[c & 0xf]);
    }
    return ret;
}*/
